# Tilde Friends
Tilde Friends is a program that aims to securely host and share pure JavaScript web applications.

## Goals
1. Make it easy and fun to run all sorts of web applications.
2. Provide a security model that is easy to understand and protects your data.
3. Make creating and sharing web applications accessible to anyone with a browser.

## Building
1. Requires libsodium and openssl.  Other dependencies are kept up to date in the tree.
2. To build, run `make` or `make DEBUG=1`.  An executable will be generated in a subdirectory of `out/`.

## Running
This is only just starting to show some signs of beginning to work as intended.  Set expectations low.

Running the built `tildefriends` executable will start a web server at <http://localhost:12345/>.  `tildefriends -h` lists further options.

The first user to create an account and log in will be granted administrative privileges.  Everything can be managed entirely from the web interface.

Some starter apps can be installed by running `tildefriends import -u cory`.  Hint: `~cory/docs/` and `~cory/index/`.

## Documentation
There are the very beginnings of developer documentation in `apps/cory/docs/` that can be read in-place or in-browser by running `tildefriends import -u cory` and then visiting <http://localhost:12345/~cory/docs/>.

## License
All code unless otherwise noted in [COPYING](https://www.unprompted.com/projects/browser/projects/tildefriends/trunk/COPYING) is provided under the [Affero GPL 3.0](https://www.unprompted.com/projects/browser/projects/tildefriends/trunk/LICENSE) license.
